// FencryptorDoc.cpp : implementation of the CFencryptorDoc class
//

#include "stdafx.h"

extern "C" {
#include "Capi.h"
}

#include "Fencryptor.h"
#include "CfgDlg.h"

#include "FencryptorDoc.h"
#include "PassDlg.h"
#include "PublicDlg.h"

#include <Winreg.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFencryptorDoc

IMPLEMENT_DYNCREATE(CFencryptorDoc, CDocument)

BEGIN_MESSAGE_MAP(CFencryptorDoc, CDocument)
	//{{AFX_MSG_MAP(CFencryptorDoc)
	ON_COMMAND(ID_TOOL_CONFIGURATION, OnToolConfiguration)
	ON_COMMAND(ID_VIEW_SIGNATURE, OnViewSignature)
	ON_COMMAND(ID_FILE_ENCRYPTANDSAVE, OnFileEncryptAndSaveAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFencryptorDoc construction/destruction

CFencryptorDoc::CFencryptorDoc()
{
	// TODO: add one-time construction code here

}

CFencryptorDoc::~CFencryptorDoc()
{
}

BOOL CFencryptorDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	((CEditView*)m_viewList.GetHead())->SetWindowText(NULL);

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CFencryptorDoc serialization

void CFencryptorDoc::Serialize(CArchive& ar)
{
	
	// CEditView contains an edit control which handles all serialization
	NoError = TRUE;
	if( ar.IsLoading() ) {
        if( UnWrapFile(ar) != 0 ) // Incomplete unwrap
		     NoError = FALSE;
	}
    else // Handle save and save as  ( no encryption )
	   ((CEditView*)m_viewList.GetHead())->SerializeRaw(ar);
}

int CFencryptorDoc::UnWrapFile(CArchive& ar)
{
    CRYPT_CONTEXT signContext = 0, decryptContext = 0;
	CRYPT_CONTEXT sessionKeyContext = 0, hashContext = 0;
	CRYPT_OBJECT_INFO cryptObjectInfo;
	BYTE *objectBuffer, *ioBuffer, *dataPtr, *signature;
	int payloadStart, dataInBuffer, count, status = CRYPT_ERROR;
	long payloadSize, dataSize, signatureSize = 0;

	/* Allocate room for the objects and read them into memory */
	if( ( objectBuffer = (unsigned char*)malloc( 4096 + 1) ) == NULL )
		return( CRYPT_NOMEM );
	if( ( ioBuffer = (unsigned char*)malloc( 4096 + 1 ) ) == NULL ) {
		free( objectBuffer );
		return( CRYPT_NOMEM );
	}

	CFileStatus st;
	CFile* infile = ar.GetFile();
    infile->GetStatus(st);
	CEditView* pEdit = (CEditView*)m_viewList.GetHead();

	if( ( dataInBuffer = infile->Read( objectBuffer, 4096) ) < 50 ) {
		if( AfxMessageBox( "The file does not appear to be\r\n"
			"encrypted with F-encryptor !!!\r\n\r\n"
			"Do you want to read it as normal file ?", MB_YESNO) == IDYES ) {
	         
			 objectBuffer[dataInBuffer] = '\0';
		     pEdit->SetWindowText( (const char*)objectBuffer);

		   return 0;
		}
		else  // Cancel
		   return 1;
	}
	dataPtr = objectBuffer;

	/* Find out what we've got */
	status = cryptQueryObject( objectBuffer, &cryptObjectInfo );
	if( cryptStatusError( status ) ) {
		if( AfxMessageBox( "The file does not appear to be\r\n"
			"encrypted with F-encryptor !!!\r\n\r\n"
			"Do you want to read it as normal file ?", MB_YESNO) == IDYES ) {
	       	
			infile->SeekToBegin();
			((CEditView*)m_viewList.GetHead())->SerializeRaw(ar);
		   return 0;
		}
		else // cancel
			return 1;
	}

try {
     if( cryptObjectInfo.type == CRYPT_OBJECT_PKCENCRYPTED_KEY || 
		cryptObjectInfo.type == CRYPT_OBJECT_ENCRYPTED_KEY ) {

        CPassDlg dlg;
		if( dlg.DoModal() != IDOK) {
			status = 0;
			throw (status);
        }
		if( cryptObjectInfo.type == CRYPT_OBJECT_ENCRYPTED_KEY ) {
            
			cryptCreateContext( &decryptContext, cryptObjectInfo.cryptAlgo,
							cryptObjectInfo.cryptMode );
			status = cryptDeriveKey( decryptContext, 
					dlg.m_passphrase, strlen(dlg.m_passphrase) );
		    if( cryptStatusError( status ) )
		            throw( status );
		}
		else {

		   CRYPT_KEYSET cryptKeyset;
           char pgppath[100];
		   if( GetEnvironmentVariable( "PGPPATH", pgppath, 100 ) == 0 ) {
			   AfxMessageBox( "PGPPATH is not set up.", MB_OK);
			   return 1;
		   }
           char secring[100];
		   sprintf(secring, "%s\\secring.pgp", pgppath);

		   /* Open the external key collection and try to read the required key */
		   status = cryptExtKeysetOpen( &cryptKeyset, secring,
	               CRYPT_KEYSET_PGP );
		   if( cryptStatusError( status ) )
			  throw (status);
		   status = cryptGetKeyFromObjectEx( cryptKeyset, &decryptContext,
										  dataPtr, dlg.m_passphrase );
		   if( cryptStatusError( status ) )
			  throw (status );
		   cryptKeysetClose( cryptKeyset );
        }

		/* Query the encrypted key object to find its size */
		status = cryptImportObject( dataPtr, &payloadStart, &payloadSize );
		if( cryptStatusError( status ) )
		   throw ( status );

		/* Recreate the session key by importing the encrypted key */
		status = cryptImportKey( dataPtr, decryptContext,
								 &sessionKeyContext );
		cryptDestroyContext( decryptContext );
		decryptContext = 0;
		if( cryptStatusError( status ) )
		   throw (status );

		/* Set up the session key to decrypt the encrypted data (there's no
		   payload for an encrypted session key so we don't need to include
		   the payload size in the calculation) */
		dataPtr += payloadStart;
		status = cryptImportObjectEx( dataPtr, &payloadStart, &payloadSize,
									  &sessionKeyContext );
		if( cryptStatusError( status ) )
			throw ( status );
	
		/* Decrypt as much of the SignedData or RawData object as we have in
		   the buffer and remember how much we still have to process */
		dataPtr += payloadStart;
		dataInBuffer -= ( int ) ( dataPtr - objectBuffer );
		status = cryptDecrypt( sessionKeyContext, dataPtr, dataInBuffer );
		if( cryptStatusError( status ) )
			throw (status );

		/* Adjust the total data size by the amount we've just decrypted */
		dataSize = payloadSize - dataInBuffer;

		/* Find out what's next */
		status = cryptQueryObject( dataPtr, &cryptObjectInfo );
		if( cryptStatusError( status ) )
			throw (status);
		}

	/* Process a SignedData object */
	if( cryptObjectInfo.type == CRYPT_OBJECT_SIGNED_DATA )
		{
		/* Import the signed data object */
		status = cryptImportObjectEx( dataPtr, &payloadStart, &payloadSize,
									  &hashContext );
		if( cryptStatusError( status ) )
			throw (status);

		/* Hash as much of the RawData object as we have in the buffer and
		   remember how much we still have to process */
		dataInBuffer -= payloadStart;
		dataPtr += payloadStart;
		dataSize = payloadSize - dataInBuffer;
		if( dataSize < 0 ) {
			/* If we've got some of the Signature object in the buffer,
			   don't hash the signature itself and remember how much of the
			   signature is already present */
			signatureSize = -dataSize;
			signature = dataPtr + ( int ) payloadSize;
			dataSize = 0;
			cryptDecrypt( hashContext, dataPtr, dataInBuffer -
						  ( int ) signatureSize );
		}
		else {
			/* Everything in the buffer is SignedData, hash the whole thing */
			signatureSize = 0;
			cryptDecrypt( hashContext, dataPtr, dataInBuffer );
		}

		/* Find out what's next */
		status = cryptQueryObject( dataPtr, &cryptObjectInfo );
		if( cryptStatusError( status ) )
			throw (status );
		}

	/* Process a RawData object */
	if( cryptObjectInfo.type != CRYPT_OBJECT_RAW_DATA )
		 throw (status);

	/* Import the raw data object and write as much of it as we have
	   available to disk */
	status = cryptImportObject( dataPtr, &payloadStart, &payloadSize );
	if( cryptStatusError( status ) )
		throw (status );
	count = ( int ) ( dataInBuffer - signatureSize - payloadStart );
	
	BufferAppend(dataPtr + payloadStart, count);

	/* Now process the input file which contains the payload portion of the
	   RawData object.  We just read the file in chunks, decrypt it, and
	   write the result to the output file */
	while( dataSize )
		{
		int bufferLength = ( int ) ( ( dataSize > BUFSIZ * 4 ) ? \
						   BUFSIZ * 4 : dataSize );

		if( ( bufferLength = infile->Read( ioBuffer, bufferLength ) ) != bufferLength )
			throw (status );
		if( sessionKeyContext )
			cryptDecrypt( sessionKeyContext, ioBuffer, bufferLength );
		if( hashContext )
			cryptDecrypt( hashContext, ioBuffer, bufferLength );
		
		BufferAppend( ioBuffer, bufferLength );
		dataSize -= bufferLength;
	}


	/* If the data is signed, read the Signature object which follows the
	   SignedData object and check the signature */
	if( hashContext )
		{
		CRYPT_KEYSET cryptKeyset;
    //    SignatureMsg = "Signature function is not implemented yet.";
		cryptDecrypt( hashContext, dataPtr, 0 );

		/* If we've already got some of the signature in the buffer, move it
		   to the start of the buffer so we can read in the rest */
		if( signatureSize )
			memmove( objectBuffer, signature, ( size_t ) signatureSize );

		/* Read the Signature object which follows the SignedData object.  We
		   may already have some or all of it in memory from previous reads.
		   The byte-by-byte read isn't terribly elegant, but much easier than
		   a cryptQueryObject() followed by a read of the payload */
		signature = objectBuffer;

		if( (long)infile->GetPosition() != st.m_size  )
			{
			int signatureIndex = ( int ) signatureSize;

			/* Read in the rest of the signature */
            int i = infile->GetPosition();
			infile->Read( signature, st.m_size - i );
            signatureIndex += st.m_size - i;
	
			/* Decrypt the signature or remainder of the signature */
			if( sessionKeyContext )
				{
				status = cryptDecrypt( sessionKeyContext,
									   signature + ( int ) signatureSize,
									   signatureIndex );
				if( cryptStatusError( status ) )
					throw (status );
				}
			}

		   char pgppath[100];
		   if( GetEnvironmentVariable( "PGPPATH", pgppath, 100 ) == 0 ) {
			   AfxMessageBox( "PGPPATH is not set up.", MB_OK);
			   return 1;
		   }
    	   char pubring[100];
		   sprintf(pubring, "%s\\pubring.pgp", pgppath);

		/* Open the external key collection and try to read the signature key */
		status = cryptExtKeysetOpen( &cryptKeyset, pubring,
									 CRYPT_KEYSET_PGP );
		if( cryptStatusError( status ) )
			throw (status );
		status = cryptGetKeyFromObject( cryptKeyset, &signContext,
										signature );
		if( cryptStatusError( status ) )
			throw (status );
		cryptKeysetClose( cryptKeyset );

		/* Check the signature */
		status = cryptCheckSignature( signature, signContext, hashContext );
		cryptDestroyContext( hashContext );
		hashContext = 0;
		cryptDestroyContext( signContext );
		signContext = 0;
		if( cryptStatusError( status ) )
			throw (status );
		}

	cryptDestroyContext( sessionKeyContext );

	/* Clean up */
	free( objectBuffer );
	/* hint to close */
	BufferAppend( NULL, NULL);
    NoError = TRUE;
	return( CRYPT_OK );
}
	/* Exception handlers */
catch (int status ) {
	if( hashContext )
		cryptDestroyContext( hashContext );
	if( sessionKeyContext )
		cryptDestroyContext( sessionKeyContext );
	if( objectBuffer != NULL )
		free( objectBuffer );
	
	char buf[100];
	if( status == -152 || status == -102 )
		strcpy( buf, "Bad Data/Wrong passphrase !!!" );
	else if( status == 0 ) /* special for dlg.DoModal==IDCANCEL*/
		return(status);
	else
		sprintf( buf, "Error code %d", status);
	AfxMessageBox( buf, MB_OK);
    NoError = FALSE;
	return( status );
  }
}

int CFencryptorDoc::BufferAppend(unsigned char* p, int count)
{
	static CString str;
	if( p != NULL ) {
		p[count] = '\0';
		str += p;
	}
	else {
	   CEditView* pEdit = (CEditView*)m_viewList.GetHead();
       pEdit->SetWindowText(str);
	   str = "";
	   str.FreeExtra();
	}
	return 0;
}

int CFencryptorDoc::BufferDeduct(unsigned char* p, int count)
{
	static CString str;
	int i;

    if( p == NULL ) {
		CEditView* pEdit = (CEditView*)m_viewList.GetHead();
		pEdit->GetWindowText(str);
	    i = strlen(str);
		return i;
	}

	i = strlen(str);
    if( i > count ) {
		strncpy( (char*)p, str, count);
		str = str.Right(i-count);
	    return count;
	}
	else {
		strncpy((char*)p, str, i);
		str = "";
	    return i;
    }
}

int CFencryptorDoc::WrapFile(CFile& outfile)
{

    CRYPT_CONTEXT cryptContext, signContext;

    GetContextFromConfig(&cryptContext, &signContext);

	CRYPT_CONTEXT sessionKeyContext = 0, hashContext = 0;
	CRYPT_IOCTLINFO_COOKIE cryptIoctlInfo;
	BYTE *objectBuffer = NULL, *encryptedObject, *signedObject, *dataObject;
	BYTE *signature;
	int exportedKeySize = 0, encryptedObjectSize = 0, signedObjectSize = 0;
	int dataObjectSize, objectSize, signatureSize = 0, status = CRYPT_ERROR;
	long dataLength;

	/* Find out how big the edit control buffer is */
	dataLength = BufferDeduct(NULL, 0);

	/* Create an encryption context for the session key and a session key if
	   we want to encrypt and a hash context for the signature if we want to
	   sign the data */
try {
	if( cryptContext )
		{

	//  Don't quite work, cheat instead. Probably because of block size not
	//  fitting block boundary. - My guess.
	//  According to Peter, the enveloping functions will make life easier.
	//	status = cryptCreateContext( &sessionKeyContext, (CRYPT_ALGO)Algo, (CRYPT_MODE)Mode );
		status = cryptCreateContext( &sessionKeyContext, (CRYPT_ALGO)Algo,  CRYPT_MODE_CFB );
		if( cryptStatusError( status ) )
			return( status );
		status = cryptGenerateContext( sessionKeyContext );
		if( cryptStatusError( status ) )
			throw (status );
		}
	
	if( signContext ) 
	    {
		status = cryptCreateContext( &hashContext, CRYPT_ALGO_SHA, CRYPT_MODE_NONE );
		if( cryptStatusError( status ) )
			 throw (status );

		/* Since the Signature object directly follows the SignedData object
		   we don't bother exporting the signature cookie.  If we were using
		   a detached signature we would use the default behaviour of
		   exporting the cookie */
		cryptIoctlInfo.exportCookie = 0;
		cryptIoctl( CRYPT_IOCTL_SIGCOOKIE, &cryptIoctlInfo, hashContext );
		}

	/* Find out how big the various objects will be.  Note the way we
	   determine the size of the nested objects: First the inner RawData
	   object, then the SignedData object surrounding it, then the
	   EncryptedData object surrounding that */
	cryptExportObject( NULL, &dataObjectSize, CRYPT_OBJECT_RAW_DATA,
					   dataLength );
	if( signContext )
		{
		/* SignedData followed by the Signature */
		cryptExportObjectEx( NULL, &signedObjectSize, CRYPT_OBJECT_SIGNED_DATA,
							 dataObjectSize + dataLength, hashContext );
		cryptCreateSignature( NULL, &signatureSize, signContext, hashContext );
		}
	if( cryptContext )
		{
		/* EncryptedKey/PKCEncryptedKey followed by the EncryptedData */
		cryptExportKey( NULL, &exportedKeySize, cryptContext, sessionKeyContext );
		cryptExportObjectEx( NULL, &encryptedObjectSize,
							 CRYPT_OBJECT_ENCRYPTED_DATA, signedObjectSize +
							 dataObjectSize + dataLength + signatureSize,
							 sessionKeyContext );
	    } 

	/* Allocate a buffer for the various objects and find the locations of
	   each object in the buffer */
	if( ( objectBuffer = (unsigned char*)malloc( exportedKeySize + encryptedObjectSize +
								 signedObjectSize + dataObjectSize +
								 signatureSize ) ) == NULL )
		throw (status );
	encryptedObject = objectBuffer + exportedKeySize;
	signedObject = encryptedObject + encryptedObjectSize;
	dataObject = signedObject + signedObjectSize;
	signature = dataObject + dataObjectSize;

	/* Export the session key */
	if( cryptContext )
		{
		status = cryptExportKey( objectBuffer, &exportedKeySize, cryptContext,
								 sessionKeyContext );
		if( cryptStatusError( status ) )
			throw (status );
		}

	/* Assemble the EncryptedData, SignedData, and RawData objects */
	if( cryptContext )
		cryptExportObjectEx( encryptedObject, &encryptedObjectSize,
							 CRYPT_OBJECT_ENCRYPTED_DATA, signedObjectSize +
							 dataObjectSize + dataLength + signatureSize,
							 sessionKeyContext );
	if( signContext )
		cryptExportObjectEx( signedObject, &signedObjectSize,
							 CRYPT_OBJECT_SIGNED_DATA, dataObjectSize +
							 dataLength, hashContext );
	    cryptExportObject( dataObject, &dataObjectSize, CRYPT_OBJECT_RAW_DATA,
					   dataLength );

	/* Hash the start of the RawData object and encrypt the start of the
	   SignedData object */
	if( signContext )
		cryptEncrypt( hashContext, dataObject, dataObjectSize );
	if( cryptContext )
		cryptEncrypt( sessionKeyContext, signedObject, signedObjectSize +
					  dataObjectSize );

	/* Write the objects to the output file */
	objectSize = exportedKeySize + encryptedObjectSize + signedObjectSize +
				 dataObjectSize;
	
	outfile.Write( objectBuffer, objectSize);

	/* Now process the input file which contains the payload portion of the
	   RawData object.  We just read the file in chunks, hash it, encrypt it,
	   and write the result to the output file */
	while( TRUE ) {
		BYTE buffer[ BUFSIZ * 4 ];
		int bufferLength;

		if( ( bufferLength = BufferDeduct( buffer, BUFSIZ * 4)) == 0 )
			break;
		if( signContext )
			cryptEncrypt( hashContext, buffer, bufferLength );
		if( cryptContext )
			cryptEncrypt( sessionKeyContext, buffer, bufferLength );
		outfile.Write( buffer, bufferLength );
	}

	/* We've passed the last general exception point, set the return value to
	   OK */
	status = CRYPT_OK;

	/* Complete the hash and create the Signature object */
	if( signContext ) {
		cryptEncrypt( hashContext, signature, 0 );
		status = cryptCreateSignature( signature, &signatureSize, signContext,
									   hashContext );
		cryptDestroyContext( hashContext );
		hashContext = 0;
		if( cryptStatusError( status ) )
			throw (status );

		/* Encrypt the Signature object and write it to the output file */
		if( cryptContext )
			status = cryptEncrypt( sessionKeyContext, signature,
								   signatureSize );
		if( cryptStatusError( status ) )
			throw (status );
		outfile.Write( signature, signatureSize);
	
	}
	cryptDestroyContext( sessionKeyContext );

	/* Clean up */
	free( objectBuffer );
	return( status );
}
	/* Exception handlers */
catch (int status) {
	if( hashContext )
		cryptDestroyContext( hashContext );
	if( sessionKeyContext )
		cryptDestroyContext( sessionKeyContext );
	if( objectBuffer != NULL )
		free( objectBuffer );

    char buf[100];
	sprintf( buf, "Error code %d", status);
	AfxMessageBox( buf, MB_OK);
	return( status );
  }
}

int CFencryptorDoc::GetContextFromConfig(
	CRYPT_CONTEXT* cryptContext, 
	CRYPT_CONTEXT* signContext)
{

	// Due to historical reason, I ended up using
	// Win32 SDK function instead of MFC functions.
	// Why bother to change as long as it works.

	HKEY hKey, hSubKey, hkResult;

	if( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software", 0, KEY_READ|KEY_CREATE_SUB_KEY, &hKey) != ERROR_SUCCESS) {
		SetDefault();
		goto resume;
    }
	
    if( RegOpenKeyEx( hKey, "Fencryptor", 0,
		KEY_READ, &hSubKey ) != ERROR_SUCCESS ) {
	    SetDefault();
	    goto resume;
    }
    RegCloseKey(hKey);

	if( RegOpenKeyEx( hSubKey, "Fencryptor", 0,    
		KEY_READ, &hkResult ) != ERROR_SUCCESS ) {
		SetDefault();
	    goto resume;
    }
	RegCloseKey(hSubKey);

	char buf[100];
	DWORD dwSize;
	DWORD dwType;

	if( RegQueryValueEx( hkResult, "Config", NULL, &dwType, NULL, &dwSize ) != ERROR_SUCCESS ) {
		SetDefault();
		goto resume;
	}

	if( RegQueryValueEx( hkResult, "Config", NULL, &dwType, (unsigned char*)buf, &dwSize ) != ERROR_SUCCESS ) {
		SetDefault();
		goto resume;
	}
	RegCloseKey(hkResult);
    
    buf[1] = buf[3] = buf[5] = buf[7] = '\0';
    KeyType = atoi(buf);
	KeySetType = atoi(buf+2);
	Algo = atoi(buf+4) + 1;
	Mode = atoi(buf+6) + 1;

resume:

try {
	int status;
	if( KeyType == 0 ) {
      CPassDlg dlg;
      if( dlg.DoModal() != IDOK) 
	     return 1;
      else { // conventional 
	     cryptCreateContext( cryptContext, 
			 (const CRYPT_ALGO)Algo, 
			 (const CRYPT_MODE)Mode);
	     status = cryptDeriveKey( *cryptContext, 
		    dlg.m_passphrase, strlen( dlg.m_passphrase ) );
         if( cryptStatusError( status ) )
			throw (status);

        *signContext = 0;
       }
	}
	else { // public key

      CPublicDlg dlg(KeyType);
	  if( dlg.DoModal() != IDOK) 
		  return 1;
	  CRYPT_KEYSET cryptKeyset;
  	  if( KeyType == 1 || KeyType == 3) {
		  status = cryptExtKeysetOpen( &cryptKeyset, dlg.pubring,
							CRYPT_KEYSET_PGP );
		  if( cryptStatusError( status ) ) {
			  sprintf( buf, "Couldn't open public key ring %s,\r\nError code %d.\n",
				   dlg.pubring, status );
				   return 1;
		  };
		  status = cryptGetKey( cryptKeyset, cryptContext, dlg.recipient );
		  if( cryptStatusError( status ) ) {
			  sprintf( buf, "Couldn't get public key for %s,\r\nError code %d.\n",
				   dlg.recipient, status );
				   return 1;
		  }
		  cryptKeysetClose( cryptKeyset );
		  if( KeyType == 1)
			  *signContext = 0;
			
	  }
	  if ( KeyType == 2 || KeyType == 3) {
		  status = cryptExtKeysetOpen( &cryptKeyset, dlg.secring,
						CRYPT_KEYSET_PGP );
		  if( cryptStatusError( status ) ) {
					sprintf( buf, "Couldn't open private key file %s,\r\nError code %d.\n",
							dlg.secring, status );
					AfxMessageBox( buf, MB_OK);
					return 1;
		  }
		  status = cryptGetKeyEx( cryptKeyset, signContext, dlg.signer, dlg.passphrase );
		  dlg.passphrase == "";
		  dlg.passphrase.FreeExtra();

		  if( cryptStatusError( status ) ) {
					sprintf( buf, "Couldn't get private key for %s,\r\nError code %d\n",
							dlg.signer, status );
					AfxMessageBox( buf, MB_OK);
					return 1;
		   }
		   cryptKeysetClose( cryptKeyset );
		   if( KeyType == 2 )
			   *cryptContext = 0;
	  }
   }
   return 0;

}
   	/* Exception handlers */
  catch(int status) {

	sprintf( buf, "Error code %d", status);
	AfxMessageBox( buf, MB_OK);
	return( status );
  }
}

void CFencryptorDoc::SetDefault()
{
	KeyType = 0;
	KeySetType = 0;
	// My algo and mode is offset by one
	// when fitting to CRYPT_ALGO and CRYPT_MODE
	// 3DES and CFB by default
	Algo = 1 + 1;
	Mode = 2 + 1;

}

/////////////////////////////////////////////////////////////////////////////
// CFencryptorDoc diagnostics

#ifdef _DEBUG
void CFencryptorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CFencryptorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFencryptorDoc commands

void CFencryptorDoc::OnToolConfiguration() 
{
	// TODO: Add your command handler code here
	CCfgDlg dlg;
	dlg.DoModal();

}

void CFencryptorDoc::OnViewSignature() 
{
	// TODO: Add your command handler code here
	SignatureMsg = "Signature function is not implemented yet.";
	AfxMessageBox( SignatureMsg, MB_OK);
}

void CFencryptorDoc::OnFileEncryptAndSaveAs() 
{
	// TODO: Add your command handler code here
	if( IsModified() ) {
		AfxMessageBox( "Document has been modified.\r\n"
			"Please save it first", MB_OK );
		return;
	}
	else {
		// Check if there is anything in Edit control
		CString str;
		CEditView* pEdit = (CEditView*)m_viewList.GetHead();
		pEdit->GetWindowText(str);
        if( str == "" )
			return;

		// Prompt
		static char BASED_CODE szFilter[] = 
	      "Cryptlib file (*.crypt)|*.crypt|Any file(*.*)|*.*||";
		str = GetPathName() + ".crypt";
	      CFileDialog dlg(FALSE, NULL, str, NULL, szFilter );
		  dlg.m_ofn.lpstrTitle = "Encrypt And Save As";
	    if( dlg.DoModal() != IDOK )
			return;
		
		// Check if file exists
		CFileStatus status;
        if( CFile::GetStatus( dlg.GetPathName(), status ) != 0 ) {
	        char buf[200];
	        sprintf(buf, "%s. \r\nThis file already exists.\r\n"
		       "Replace Existing file ?", dlg.GetPathName());
	        // This number 6 is obtained from experimentation 
	        if( AfxMessageBox( buf, MB_YESNO) !=  IDYES)
				return;
			else
		         CFile::Remove( dlg.GetPathName() );
        }
	    
		CFile f;
        if( f.Open( dlg.GetPathName(), CFile::modeCreate | CFile::modeWrite ) ) {
  			WrapFile(f);
			f.Close();
		}
	}
	
}

BOOL CFencryptorDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// TODO: Add your specialized creation code here
	if( NoError == FALSE)
		return FALSE;
	return TRUE;
}
